petsc-3.10.5 2019-03-28
Report Typos and Errors

# PetscOptionsGetString

Gets the string value for a particular option in the database.

### Synopsis

    #include "petscsys.h"
    PetscErrorCode PetscOptionsGetString(PetscOptions options,const char pre[],const char name[],char string[],size_t len,PetscBool *set)

Not Collective

### Input Parameters

| options | - options database, use NULL for default global database
| pre | - string to prepend to name or NULL
| name | - the option one is seeking
| len | - maximum length of the string including null termination

### Output Parameters

| string | - location to copy string
| set | - PETSC_TRUE if found, else PETSC_FALSE

### Fortran Note

The Fortran interface is slightly different from the C/C++ interface (len is not used). Sample usage in Fortran follows

          character *20    string
          PetscErrorCode   ierr
          PetscBool        set
          call PetscOptionsGetString(PETSC_NULL_OPTIONS,PETSC_NULL_CHARACTER,'-s',string,set,ierr)

### Notes

if the option is given but no string is provided then an empty string is returned and set is given the value of PETSC_TRUE

If the user does not use the option then the string is not changed. Thus you should ALWAYS initialize the string if you access it without first checking if the set flag is true.

### Note

Even if the user provided no string (for example -optionname -someotheroption) the flag is set to PETSC_TRUE (and the string is fulled with nulls).

### See Also

PetscOptionsGetInt(), PetscOptionsGetReal(),
PetscOptionsHasName(), PetscOptionsGetIntArray(), PetscOptionsGetRealArray(), PetscOptionsBool(), PetscOptionsName(), PetscOptionsBegin(), PetscOptionsEnd(), PetscOptionsHead(), PetscOptionsStringArray(),PetscOptionsRealArray(), PetscOptionsScalar(), PetscOptionsBoolGroupBegin(), PetscOptionsBoolGroup(), PetscOptionsBoolGroupEnd(), PetscOptionsFList(), PetscOptionsEList()

### Level

beginner

### Location

src/sys/objects/options.c

### Examples

src/sys/examples/tutorials/ex5.c.html
src/sys/examples/tutorials/ex9.c.html
src/sys/examples/tutorials/ex10f90.F90.html
src/mat/examples/tutorials/ex1.c.html
src/mat/examples/tutorials/ex5.c.html
src/mat/examples/tutorials/ex9.c.html
src/mat/examples/tutorials/ex10.c.html
src/mat/examples/tutorials/ex12.c.html
src/mat/examples/tutorials/ex16.c.html
src/ksp/ksp/examples/tutorials/ex10.c.html
src/ksp/ksp/examples/tutorials/ex27.c.html
Index of all Sys routines
Table of Contents for all manual pages
Index of all manual pages